<?php
/*
Plugin Name: Folding@Home Stats
Plugin URI: http://www.j2fi.net/2007/03/23/foldinghome-wordpress-plugin/
Description: Display current Folding@Home stats
Version: 0.1
Author: Jason F. Irwin Jfi
Author URI: http://www.j2fi.net/
Disclaimer: Use at your own risk. No warranty expressed or implied is provided.

*/

/*	Copyright 2007  Jason F. Irwin Jfi  (email: jason@j2fi.net)
	
	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* *****INSTRUCTIONS*****

  Installation
  ============
  Upload the folder "folding-stats" into your "wp-content/plugins"
  Log in to Wordpress Administration area, choose "Plugins" from the main menu, find "Folding@Home Stats", and click the "Activate" button 
  Choose "Options->Folding Options" from the main menu and enter your Folding@Home Account ID and cache refresh hours

  Upgrading
  =========
  Just overwrite the previous version and follow the Installation instructions.
  
  Configuration
  =============
  Modify your theme (usually your sidebar.php) by adding the following php code:
  
  get_folding_stats()
  
  Don't forget to wrap this in a proper php structure!
  
  Uninstallation
  ==============
  Log in to Wordpress Administration area, choose Plugins from the main menu, find the name of the plugin Folding@Home Stats, and click the Deactivate button

  ***********************
  Change Log
  ----------
  0.1 - (Mar 23/07)
	  	- Initial Release
*/

function fold_init() {
  	define('FOLD_ACCT', get_option('fold_acct'));
  	define('FOLD_EXPY', get_option('fold_expy'));
}
add_action('init','fold_init');

define('FOLD_FILE', ABSPATH . 'wp-content/plugins/folding-stats/folding_cache.txt');

function get_folding_stats() {
	//Get the Write Time
	$fh = fopen(FOLD_FILE, 'r');
	$expiry = fread($fh, 10);
	fclose($fh);

	//Date Compare
	$today = mktime(date("H"), 0, 0, date("m"), date("d"), date("y"));

	if ($expiry < $today) {
		//Get Fresh Data
		read_fold_site();
	}
	
	//Read Data From Cache
	$fg = fopen(FOLD_FILE, 'r');
	$out = fread($fg, filesize(FOLD_FILE));
	fclose($fg);

	//Output
	$out = substr($out, 10, strlen($out));
	echo $out;
}

function read_fold_site() {
	$host = 'fah-web.stanford.edu';
	$path = '/cgi-bin/main.py?qtype=userpage&username=' . FOLD_ACCT;
	$stats_url = 'http://fah-web.stanford.edu/cgi-bin/main.py?qtype=userpage&username=' . FOLD_ACCT;
	$fold_logo = get_settings('home') . '/wp-content/plugins/folding-stats/FAHlogoML.jpg';
	$fold_url = 'http://folding.stanford.edu/';

	//Get the site data and trim to something managable
	$sFile = file_get_contents($stats_url, False);
	$sfile = substr($sfile, 0, 2000);

  $last_upd = strstr($sFile, 'Date of last work unit');
  $credit = strstr($sFile, 'Total score');
	$ov_rank = strstr($sFile, 'Overall rank');
	$FiftyProc = strstr($sFile, 'within 50 days');
	$SevenProc = strstr($sFile, 'within 7 days');
	
	//Parse Strings
	$last_upd = substr($last_upd, strpos($last_upd, '=4>') + 4, 12);
	$last_upd = substr($last_upd, 0, strpos($last_upd, '<'));
	$credit = substr($credit, strpos($credit, '=4>') + 4, 12);
	$credit = substr($credit, 0, strpos($credit, '<'));
	$ov_rank = substr($ov_rank, strpos($ov_rank, '=4>') + 4, 20);
	$ov_rank = substr($ov_rank, 0, strpos($ov_rank, '<'));
	$FiftyProc = substr($FiftyProc, strpos($FiftyProc, '=4>') + 4, 12);
	$FiftyProc = substr($FiftyProc, 0, strpos($FiftyProc, '<'));
	$SevenProc = substr($SevenProc, strpos($SevenProc, '=4>') + 4, 12);
	$SevenProc = substr($SevenProc, 0, strpos($SevenProc, '<'));

	$expire = mktime(date("H")+FOLD_EXPY, 0, 0, date("m"), date("d"), date("y"));

	//Write to Cache
	$fh = fopen(FOLD_FILE, 'w') or die("can't open file");
	$stringData = $expire;
	$stringData .= " <li> Total Score: <BR> $credit </li>";
	$stringData .= " <li> Overall Rank: <BR> $ov_rank </li>";
	$stringData .= " <li> 50 Day Procs: $FiftyProc </li>";
	$stringData .= " <li> 7 Day Procs: $SevenProc </li>";
	$stringData .= " <li> Last Update: <BR> $last_upd </li>";
	$stringData .= " <ul> <a href=$fold_url ><img src=$fold_logo /></a> </ul>";
	fwrite($fh, $stringData);
	fclose($fh);
}

/** filters**/
add_action('admin_head', 'fold_add_options_page');

function fold_add_options_page() {
	add_options_page('Folding Options', 'Folding Options', 'manage_options', 'folding-stats/options-folding.php');

	$expire = mktime(date("H")-FOLD_EXPY, 0, 0, date("m"), date("d"), date("y"));

	//Create the Cache
	$fh = fopen(FOLD_FILE, 'w') or die("can't open file");
	$stringData = $expire;
	fwrite($fh, $stringData);
	fclose($fh);
}

?>